

import { EventTouch, Node, Toggle, _decorator } from "cc";
import { oops } from "../../../../../extensions/oops-plugin-framework/assets/core/Oops";
import { ecs } from "../../../../../extensions/oops-plugin-framework/assets/libs/ecs/ECS";
import { CCComp } from "../../../../../extensions/oops-plugin-framework/assets/module/common/CCComp";
import { UIID } from "../../common/config/GameUIConfig";
import { SingletonModuleComp } from "../../common/SingletonModuleComp";
import { AdManager } from "../../../platform/ad/AdManager";
import { FullVehicleOperationComp } from "../bll/FullVehicleOperation";


const { ccclass, property } = _decorator;

/** 角色信息界面 */
@ccclass('CheckpointLeaveViewComp')
@ecs.register('CheckpointLeaveView', false)
export class CheckpointLeaveViewComp extends CCComp {

    private btnClose
    private btnGiveup
    private btnGet

    onAdded(args: any) {
        console.log(args);
    }

    onLoad() {
        this.btnClose = this.node.getChildByPath("BG/btn_close")
        this.btnGiveup = this.node.getChildByPath("BG/btn_giveup")
        this.btnGet = this.node.getChildByPath("BG/btn_get")
        this.btnClose.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.btnGiveup.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.btnGet.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);
    }

    private onTouchEnd(event: EventTouch) {
        switch (event.target.name) {
            case "btn_close":
                oops.gui.remove(UIID.VehicleLeave);
                break;
            case "btn_giveup":
                oops.gui.remove(UIID.VehicleLeave);
                break;
            case "btn_get":
                // ecs.getSingleton(SingletonModuleComp).account.checkpoint.add(FullVehicleOperationComp)
                // ecs.getSingleton(SingletonModuleComp).account.checkpoint.CheckpointModelBase.vm.leaveCount += 1
                AdManager.getInstance().showRewardVideoAd(() => {
                    console.log('成功看完广告')
                    ecs.getSingleton(SingletonModuleComp).account.checkpoint.add(FullVehicleOperationComp)
                    ecs.getSingleton(SingletonModuleComp).account.checkpoint.CheckpointModelBase.vm.leaveCount += 1
                    oops.gui.remove(UIID.VehicleLeave);
                })
                break;
        }

        event.propagationStopped = true;
    }

    reset() {
        this.node.destroy();
    }
}